From 6664d3d2f1a61163c103535b2fc5754d7fb0a52a Mon Sep 17 00:00:00 2001
From: Peter Eisentraut <peter@eisentraut.org>
Date: Thu, 27 Jun 2024 14:10:44 +0200
Subject: [PATCH v14 01/15] WIP: SQL Property Graph Queries (SQL/PGQ)

Implementation of SQL property graph queries, according to SQL/PGQ
standard (ISO 9075-16:2023).

Author: Peter Eisentraut <peter@eisentraut.org>
Author: Ashutosh Bapat <ashutosh.bapat.oss@gmail.com>
Discussion: https://www.postgresql.org/message-id/flat/a855795d-e697-4fa5-8698-d20122126567@eisentraut.org

Description of fixes added to the original patch

1. Fixes suggested by pgperltidy.

2. binary_upgrade_set_pg_class_oid() call fix: After
   6e1c4a03a978ed3574124d8f2be22ba2e5a4b1e9
   binary_upgrade_set_pg_class_oid() doesn't need the (now non-existent)
   last argument.

3. decompile_column_index_array() call fix:
   89f908a6d0ac1337c868625008c9598487d184e7 added a new parameter
   withPeriod to decompile_column_index_array(). This function is used
   to decompile keys in property graph definition. KEYs in property
   graph definition are not temporal and thus do not need to specify
   PERIOD in their definition. Hence pass `false` to
   decompile_column_index_array() when called for while decompiling a
   property graph definition.

4. Spurious column not found error: Attribute name from a heap tuple
   needs to be copied before releasing the resources held by the tuple
   and the table scan.

5. Merge conflict fixes in parser.pl: after ECPG related refactoring
   from commits around 6b005499447512abfa1e4add87dcf3e2859c4f9e.

6. Merge conflict in alter.c and aclchk.c when merging with HEAD =
   aac831cafa6f3106dfcbd3298757801c299351fc

7. Fix compilation error in propgraph_element_get_key():
RelationGetPrimaryKeyIndex(), called by propgraph_element_get_key() requires a
second argument specifying whether DEFERRED primary key constraints are
acceptable. SQL/PGQ standard section 9.12, Syntax Rule 4 mentions only primary
key and does not discuss DEFERREDness. Fix compilation failure by passing "true"
to RelationGetPrimaryKeyIndex() as second argument. No adjustment to the
documentation is needed since it mentioned primary key without DEFERREDness.

8. Merge conflict fixes to gram.y, psql-ref.sgml, psql/help.c,
   primnodes.h when merging with HEAD =
   fd4c4ede708fc5affb04362bb5a8bdc3136fa963

9. Merge conflict fixes to gram.y, describe.c and parallel_schedule when
   merging with HEAD = 75eb9766ec201b62f264554019757716093e2a2f
---
 doc/src/sgml/catalogs.sgml                    |  471 ++++-
 doc/src/sgml/ddl.sgml                         |  225 ++-
 doc/src/sgml/features.sgml                    |    4 +-
 doc/src/sgml/func.sgml                        |   15 +
 doc/src/sgml/information_schema.sgml          | 1092 +++++++++++
 .../sgml/keywords/sql2023-16-nonreserved.txt  |   27 +
 doc/src/sgml/keywords/sql2023-16-reserved.txt |   12 +
 doc/src/sgml/queries.sgml                     |  168 ++
 doc/src/sgml/ref/allfiles.sgml                |    3 +
 doc/src/sgml/ref/alter_extension.sgml         |    3 +-
 doc/src/sgml/ref/alter_property_graph.sgml    |  299 +++
 doc/src/sgml/ref/comment.sgml                 |    1 +
 doc/src/sgml/ref/create_property_graph.sgml   |  310 +++
 doc/src/sgml/ref/drop_property_graph.sgml     |  111 ++
 doc/src/sgml/ref/grant.sgml                   |    7 +-
 doc/src/sgml/ref/psql-ref.sgml                |   13 +-
 doc/src/sgml/ref/revoke.sgml                  |    7 +
 doc/src/sgml/ref/security_label.sgml          |    1 +
 doc/src/sgml/ref/select.sgml                  |   43 +
 doc/src/sgml/reference.sgml                   |    3 +
 src/backend/catalog/aclchk.c                  |   24 +
 src/backend/catalog/dependency.c              |   11 +
 src/backend/catalog/information_schema.sql    |  364 ++++
 src/backend/catalog/objectaddress.c           |  306 +++
 src/backend/catalog/pg_class.c                |    2 +
 src/backend/catalog/sql_features.txt          |  100 +
 src/backend/commands/Makefile                 |    1 +
 src/backend/commands/alter.c                  |   28 +-
 src/backend/commands/dropcmds.c               |    1 +
 src/backend/commands/event_trigger.c          |    2 +
 src/backend/commands/meson.build              |    1 +
 src/backend/commands/propgraphcmds.c          | 1706 +++++++++++++++++
 src/backend/commands/seclabel.c               |    1 +
 src/backend/commands/tablecmds.c              |   16 +
 src/backend/executor/execMain.c               |   15 +-
 src/backend/nodes/nodeFuncs.c                 |   72 +
 src/backend/nodes/outfuncs.c                  |    5 +
 src/backend/nodes/readfuncs.c                 |    5 +
 src/backend/optimizer/path/allpaths.c         |    4 +
 src/backend/optimizer/prep/prepjointree.c     |    8 +
 src/backend/parser/Makefile                   |    1 +
 src/backend/parser/analyze.c                  |  298 +--
 src/backend/parser/gram.y                     |  708 ++++++-
 src/backend/parser/meson.build                |    1 +
 src/backend/parser/parse_agg.c                |   11 +
 src/backend/parser/parse_clause.c             |   89 +
 src/backend/parser/parse_collate.c            |    7 +
 src/backend/parser/parse_expr.c               |    6 +
 src/backend/parser/parse_func.c               |    3 +
 src/backend/parser/parse_graphtable.c         |  209 ++
 src/backend/parser/parse_relation.c           |   98 +-
 src/backend/parser/parse_target.c             |    5 +
 src/backend/parser/scan.l                     |   13 +-
 src/backend/rewrite/Makefile                  |    1 +
 src/backend/rewrite/meson.build               |    1 +
 src/backend/rewrite/rewriteGraphTable.c       | 1097 +++++++++++
 src/backend/rewrite/rewriteHandler.c          |   11 +
 src/backend/tcop/utility.c                    |   34 +
 src/backend/utils/adt/ruleutils.c             |  537 ++++++
 src/backend/utils/cache/lsyscache.c           |   38 +
 src/bin/pg_dump/common.c                      |    3 +-
 src/bin/pg_dump/pg_backup_archiver.c          |    1 +
 src/bin/pg_dump/pg_dump.c                     |   67 +-
 src/bin/pg_dump/t/002_pg_dump.pl              |   12 +
 src/bin/psql/command.c                        |    3 +-
 src/bin/psql/describe.c                       |   43 +-
 src/bin/psql/help.c                           |    1 +
 src/bin/psql/tab-complete.in.c                |   67 +-
 src/fe_utils/psqlscan.l                       |    8 +-
 src/include/catalog/Makefile                  |    7 +-
 src/include/catalog/meson.build               |    5 +
 src/include/catalog/pg_class.h                |    1 +
 src/include/catalog/pg_proc.dat               |    3 +
 src/include/catalog/pg_propgraph_element.h    |  103 +
 .../catalog/pg_propgraph_element_label.h      |   51 +
 src/include/catalog/pg_propgraph_label.h      |   51 +
 .../catalog/pg_propgraph_label_property.h     |   59 +
 src/include/catalog/pg_propgraph_property.h   |   54 +
 src/include/commands/propgraphcmds.h          |   23 +
 src/include/nodes/parsenodes.h                |  139 ++
 src/include/nodes/primnodes.h                 |   22 +
 src/include/parser/analyze.h                  |    3 +
 src/include/parser/kwlist.h                   |    9 +
 src/include/parser/parse_graphtable.h         |   31 +
 src/include/parser/parse_node.h               |    1 +
 src/include/parser/parse_relation.h           |    8 +
 src/include/rewrite/rewriteGraphTable.h       |   21 +
 src/include/tcop/cmdtaglist.h                 |    3 +
 src/include/utils/acl.h                       |    1 +
 src/include/utils/lsyscache.h                 |    3 +
 src/interfaces/ecpg/preproc/parse.pl          |    6 +-
 src/interfaces/ecpg/preproc/pgc.l             |   12 +-
 src/pl/plpgsql/src/pl_gram.y                  |    1 +
 src/test/regress/expected/alter_generic.out   |   51 +-
 .../expected/create_property_graph.out        |  496 +++++
 src/test/regress/expected/graph_table.out     |  484 +++++
 src/test/regress/expected/object_address.out  |   14 +-
 src/test/regress/expected/oidjoins.out        |   11 +
 src/test/regress/parallel_schedule            |    4 +-
 src/test/regress/sql/alter_generic.sql        |   34 +
 .../regress/sql/create_property_graph.sql     |  190 ++
 src/test/regress/sql/graph_table.sql          |  336 ++++
 src/test/regress/sql/object_address.sql       |    4 +-
 src/tools/pgindent/typedefs.list              |   21 +
 104 files changed, 10918 insertions(+), 204 deletions(-)
 create mode 100644 doc/src/sgml/keywords/sql2023-16-nonreserved.txt
 create mode 100644 doc/src/sgml/keywords/sql2023-16-reserved.txt
 create mode 100644 doc/src/sgml/ref/alter_property_graph.sgml
 create mode 100644 doc/src/sgml/ref/create_property_graph.sgml
 create mode 100644 doc/src/sgml/ref/drop_property_graph.sgml
 create mode 100644 src/backend/commands/propgraphcmds.c
 create mode 100644 src/backend/parser/parse_graphtable.c
 create mode 100644 src/backend/rewrite/rewriteGraphTable.c
 create mode 100644 src/include/catalog/pg_propgraph_element.h
 create mode 100644 src/include/catalog/pg_propgraph_element_label.h
 create mode 100644 src/include/catalog/pg_propgraph_label.h
 create mode 100644 src/include/catalog/pg_propgraph_label_property.h
 create mode 100644 src/include/catalog/pg_propgraph_property.h
 create mode 100644 src/include/commands/propgraphcmds.h
 create mode 100644 src/include/parser/parse_graphtable.h
 create mode 100644 src/include/rewrite/rewriteGraphTable.h
 create mode 100644 src/test/regress/expected/create_property_graph.out
 create mode 100644 src/test/regress/expected/graph_table.out
 create mode 100644 src/test/regress/sql/create_property_graph.sql
 create mode 100644 src/test/regress/sql/graph_table.sql

diff --git a/doc/src/sgml/catalogs.sgml b/doc/src/sgml/catalogs.sgml
index fb050635551..a7cd262942e 100644
--- a/doc/src/sgml/catalogs.sgml
+++ b/doc/src/sgml/catalogs.sgml
@@ -240,6 +240,31 @@
       <entry>functions and procedures</entry>
      </row>
 
+     <row>
+      <entry><link linkend="catalog-pg-propgraph-element"><structname>pg_propgraph_element</structname></link></entry>
+      <entry>property graph elements (vertices and edges)</entry>
+     </row>
+
+     <row>
+      <entry><link linkend="catalog-pg-propgraph-element-label"><structname>pg_propgraph_element_label</structname></link></entry>
+      <entry>property graph links between elements and labels</entry>
+     </row>
+
+     <row>
+      <entry><link linkend="catalog-pg-propgraph-label"><structname>pg_propgraph_label</structname></link></entry>
+      <entry>property graph labels</entry>
+     </row>
+
+     <row>
+      <entry><link linkend="catalog-pg-propgraph-label-property"><structname>pg_propgraph_label_property</structname></link></entry>
+      <entry>property graph label-specific property definitions</entry>
+     </row>
+
+     <row>
+      <entry><link linkend="catalog-pg-propgraph-property"><structname>pg_propgraph_property</structname></link></entry>
+      <entry>property graph properties</entry>
+     </row>
+
      <row>
       <entry><link linkend="catalog-pg-publication"><structname>pg_publication</structname></link></entry>
       <entry>publications for logical replication</entry>
@@ -2143,7 +2168,8 @@ SCRAM-SHA-256$<replaceable>&lt;iteration count&gt;</replaceable>:<replaceable>&l
        <literal>c</literal> = composite type,
        <literal>f</literal> = foreign table,
        <literal>p</literal> = partitioned table,
-       <literal>I</literal> = partitioned index
+       <literal>I</literal> = partitioned index,
+       <literal>g</literal> = property graph
       </para></entry>
      </row>
 
@@ -6311,6 +6337,449 @@ SCRAM-SHA-256$<replaceable>&lt;iteration count&gt;</replaceable>:<replaceable>&l
 
  </sect1>
 
+ <sect1 id="catalog-pg-propgraph-element">
+  <title><structname>pg_propgraph_element</structname></title>
+
+  <indexterm zone="catalog-pg-propgraph-element">
+   <primary>pg_propgraph_element</primary>
+  </indexterm>
+
+  <para>
+   The catalog <structname>pg_propgraph_element</structname> stores
+   information about the vertices and edges of a property graph, collectively
+   called the elements of the property graph.
+  </para>
+
+  <table>
+   <title><structname>pg_propgraph_element</structname> Columns</title>
+   <tgroup cols="1">
+    <thead>
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       Column Type
+      </para>
+      <para>
+       Description
+      </para></entry>
+     </row>
+    </thead>
+
+    <tbody>
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>oid</structfield> <type>oid</type>
+      </para>
+      <para>
+       Row identifier
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgepgid</structfield> <type>oid</type>
+       (references <link linkend="catalog-pg-class"><structname>pg_class</structname></link>.<structfield>oid</structfield>)
+      </para>
+      <para>
+       Reference to the property graph that this element belongs to
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgerelid</structfield> <type>oid</type>
+       (references <link linkend="catalog-pg-class"><structname>pg_class</structname></link>.<structfield>oid</structfield>)
+      </para>
+      <para>
+       Reference to the table to contains the data for this property graph element
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgealias</structfield> <type>name</type>
+      </para>
+      <para>
+       The alias of the element.  This is a unique identifier for the element
+       within the graph.  It is set when the property graph is defined and
+       defaults to the name of the underlying element table.
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgekind</structfield> <type>char</type>
+      </para>
+      <para>
+       <literal>v</literal> for a vertex, <literal>e</literal> for an edge
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgesrcvertexid</structfield> <type>oid</type>
+       (references <link linkend="catalog-pg-propgraph-element"><structname>pg_propgraph_element</structname></link>.<structfield>oid</structfield>)
+      </para>
+      <para>
+       For an edge, a link to the source vertex.  (Zero for a vertex.)
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgedestvertexid</structfield> <type>oid</type>
+       (references <link linkend="catalog-pg-propgraph-element"><structname>pg_propgraph_element</structname></link>.<structfield>oid</structfield>)
+      </para>
+      <para>
+       For an edge, a link to the destination vertex.  (Zero for a vertex.)
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgekey</structfield> <type>int2[]</type>
+       (references <link linkend="catalog-pg-attribute"><structname>pg_attribute</structname></link>.<structfield>attnum</structfield>)
+      </para>
+      <para>
+       An array of column numbers in the table referenced by
+       <structname>pgerelid</structname> that defines the key to use for this
+       element table.  (This defaults to the primary key when the property
+       graph is created.)
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgesrckey</structfield> <type>int2[]</type>
+       (references <link linkend="catalog-pg-attribute"><structname>pg_attribute</structname></link>.<structfield>attnum</structfield>)
+      </para>
+      <para>
+       For an edge, an array of column numbers in the table referenced by
+       <structname>pgerelid</structname> that defines the source key to use
+       for this element table.  (Null for a vertex.)  The combination of
+       <structfield>pgesrckey</structfield> and
+       <structfield>pgesrcref</structfield> creates the link between the edge
+       and the source vertex.
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgesrcref</structfield> <type>int2[]</type>
+       (references <link linkend="catalog-pg-attribute"><structname>pg_attribute</structname></link>.<structfield>attnum</structfield>)
+      </para>
+      <para>
+       For an edge, an array of column numbers in the table reached via
+       <structname>pgesrcvertexid</structname>.  (Null for a vertex.)  The
+       combination of <structfield>pgesrckey</structfield> and
+       <structfield>pgesrcref</structfield> creates the link between the edge
+       and the source vertex.
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgedestkey</structfield> <type>int2[]</type>
+       (references <link linkend="catalog-pg-attribute"><structname>pg_attribute</structname></link>.<structfield>attnum</structfield>)
+      </para>
+      <para>
+       For an edge, an array of column numbers in the table referenced by
+       <structname>pgerelid</structname> that defines the destination key to use
+       for this element table.  (Null for a vertex.)  The combination of
+       <structfield>pgedestkey</structfield> and
+       <structfield>pgedestref</structfield> creates the link between the edge
+       and the destination vertex.
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgedestref</structfield> <type>int2[]</type>
+       (references <link linkend="catalog-pg-attribute"><structname>pg_attribute</structname></link>.<structfield>attnum</structfield>)
+      </para>
+      <para>
+       For an edge, an array of column numbers in the table reached via
+       <structname>pgedestvertexid</structname>.  (Null for a vertex.)  The
+       combination of <structfield>pgedestkey</structfield> and
+       <structfield>pgedestref</structfield> creates the link between the edge
+       and the destination vertex.
+      </para></entry>
+     </row>
+    </tbody>
+   </tgroup>
+  </table>
+ </sect1>
+
+ <sect1 id="catalog-pg-propgraph-element-label">
+  <title><structname>pg_propgraph_element_label</structname></title>
+
+  <indexterm zone="catalog-pg-propgraph-element-label">
+   <primary>pg_propgraph_element_label</primary>
+  </indexterm>
+
+  <para>
+   The catalog <structname>pg_propgraph_element_label</structname> stores
+   information about which labels apply to which elements.
+  </para>
+
+  <table>
+   <title><structname>pg_propgraph_element_label</structname> Columns</title>
+   <tgroup cols="1">
+    <thead>
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       Column Type
+      </para>
+      <para>
+       Description
+      </para></entry>
+     </row>
+    </thead>
+
+    <tbody>
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>oid</structfield> <type>oid</type>
+      </para>
+      <para>
+       Row identifier
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgellabelid</structfield> <type>oid</type>
+       (references <link linkend="catalog-pg-propgraph-label"><structname>pg_propgraph_label</structname></link>.<structfield>oid</structfield>)
+      </para>
+      <para>
+       Reference to the label
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgelelid</structfield> <type>oid</type>
+       (references <link linkend="catalog-pg-propgraph-element"><structname>pg_propgraph_element</structname></link>.<structfield>oid</structfield>)
+      </para>
+      <para>
+       Reference to the element
+      </para></entry>
+     </row>
+    </tbody>
+   </tgroup>
+  </table>
+ </sect1>
+
+ <sect1 id="catalog-pg-propgraph-label">
+  <title><structname>pg_propgraph_label</structname></title>
+
+  <indexterm zone="catalog-pg-propgraph-label">
+   <primary>pg_propgraph_label</primary>
+  </indexterm>
+
+  <para>
+   The catalog <structname>pg_propgraph_label</structname> stores
+   information about the labels in a property graph.
+  </para>
+
+  <table>
+   <title><structname>pg_propgraph_label</structname> Columns</title>
+   <tgroup cols="1">
+    <thead>
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       Column Type
+      </para>
+      <para>
+       Description
+      </para></entry>
+     </row>
+    </thead>
+
+    <tbody>
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>oid</structfield> <type>oid</type>
+      </para>
+      <para>
+       Row identifier
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pglpgid</structfield> <type>oid</type>
+       (references <link linkend="catalog-pg-class"><structname>pg_class</structname></link>.<structfield>oid</structfield>)
+      </para>
+      <para>
+       Reference to the property graph that this label belongs to
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgllabel</structfield> <type>name</type>
+      </para>
+      <para>
+       The name of the label.  This is unique among the labels in a graph.
+      </para></entry>
+     </row>
+    </tbody>
+   </tgroup>
+  </table>
+ </sect1>
+
+ <sect1 id="catalog-pg-propgraph-label-property">
+  <title><structname>pg_propgraph_label_property</structname></title>
+
+  <indexterm zone="catalog-pg-propgraph-label-property">
+   <primary>pg_propgraph_label_property</primary>
+  </indexterm>
+
+  <para>
+   The catalog <structname>pg_propgraph_label_property</structname> stores
+   information about the properties in a property graph that are specific to a
+   label.  In particular, this stores the expression that defines the
+   property.
+  </para>
+
+  <table>
+   <title><structname>pg_propgraph_label_property</structname> Columns</title>
+   <tgroup cols="1">
+    <thead>
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       Column Type
+      </para>
+      <para>
+       Description
+      </para></entry>
+     </row>
+    </thead>
+
+    <tbody>
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>oid</structfield> <type>oid</type>
+      </para>
+      <para>
+       Row identifier
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>plppropid</structfield> <type>oid</type>
+       (references <link linkend="catalog-pg-propgraph-property"><structname>pg_propgraph_property</structname></link>.<structfield>oid</structfield>)
+      </para>
+      <para>
+       Reference to the property
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>plpellabelid</structfield> <type>oid</type>
+       (references <link linkend="catalog-pg-propgraph-element-label"><structname>pg_propgraph_element_label</structname></link>.<structfield>oid</structfield>)
+      </para>
+      <para>
+       Reference to the label (indirectly via
+       <structname>pg_propgraph_element_label</structname>, which then links
+       to <structname>pg_propgraph_label</structname>)
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>plpexpr</structfield> <type>pg_node_tree</type>
+      </para>
+      <para>
+       Expression tree (in <function>nodeToString()</function> representation)
+       for the property's definition.  The expression references the table
+       reached via <structname>pg_propgraph_element_label</structname> and
+       <structname>pg_propgraph_element</structname>.
+      </para></entry>
+     </row>
+    </tbody>
+   </tgroup>
+  </table>
+ </sect1>
+
+ <sect1 id="catalog-pg-propgraph-property">
+  <title><structname>pg_propgraph_property</structname></title>
+
+  <indexterm zone="catalog-pg-propgraph-property">
+   <primary>pg_propgraph_property</primary>
+  </indexterm>
+
+  <para>
+   The catalog <structname>pg_propgraph_property</structname> stores
+   information about the properties in a property graph.  This only stores
+   information that applies to a property throughout the graph, independent of
+   what label or element it is on.  Additional information, including the
+   actual expressions that define the properties are in the catalog <link
+   linkend="catalog-pg-propgraph-label-property"><structname>pg_propgraph_label_property</structname></link>.
+  </para>
+
+  <table>
+   <title><structname>pg_propgraph_property</structname> Columns</title>
+   <tgroup cols="1">
+    <thead>
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       Column Type
+      </para>
+      <para>
+       Description
+      </para></entry>
+     </row>
+    </thead>
+
+    <tbody>
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>oid</structfield> <type>oid</type>
+      </para>
+      <para>
+       Row identifier
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgppgid</structfield> <type>oid</type>
+       (references <link linkend="catalog-pg-class"><structname>pg_class</structname></link>.<structfield>oid</structfield>)
+      </para>
+      <para>
+       Reference to the property graph that this property belongs to
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgpname</structfield> <type>name</type>
+      </para>
+      <para>
+       The name of the property.  This is unique among the properties in a
+       graph.
+      </para></entry>
+     </row>
+
+     <row>
+      <entry role="catalog_table_entry"><para role="column_definition">
+       <structfield>pgptypid</structfield> <type>oid</type>
+       (references <link linkend="catalog-pg-type"><structname>pg_type</structname></link>.<structfield>oid</structfield>)
+      </para>
+      <para>
+       The data type of this property.  (This is required to be fixed for a
+       given property in a property graph, even if the property is defined
+       multiple times in different elements and labels.)
+      </para></entry>
+     </row>
+    </tbody>
+   </tgroup>
+  </table>
+ </sect1>
+
  <sect1 id="catalog-pg-publication">
   <title><structname>pg_publication</structname></title>
 
